#include "induct.h"

/*=================================================
       input parser
***************************************************/

void
getinput()
{
  input_conductor *tmp,*tmp2;
  char input[100];

  /* get a line */

  while(readline(input) != EOF)
  {
    /* allocate space for the new conductor */
    tmp = (input_conductor *) malloc( sizeof(input_conductor));
    /* input the data of the new conductor */
    sscanf(input,"%d %lf %lf %lf %lf %lf %d %d %lf %lf %d %d",
                &tmp->cnum, 
                &tmp->xll, &tmp->yll, &tmp->xur, &tmp->yur, 
                &tmp->lam2, 
                &tmp->xnum, &tmp->ynum,
                &tmp->xratio, &tmp->yratio, 
                &tmp->xtype, &tmp->ytype);

    tmp->next = NULL;

    /* square lambda */
    tmp->lam2 = tmp->lam2 * tmp->lam2;

    /* if a GND conductor, group it with all GND conductors */
    if(tmp->cnum >= 100) 
    {
      tmp->cnum = 100;
      /* and put it at the beginning */
      tmp->next = input_cond;
      input_cond = tmp;
    }
    else
    {
      /* find another of the same conductor, or go to the end of the line */
      for(tmp2 = input_cond; ((tmp2->next != NULL) && (tmp2->cnum != tmp->cnum)); 
                        tmp2 = tmp2->next);

      /* put in the new conductor */
      tmp->next = tmp2->next;
      tmp2->next = tmp;
    }
  
  } /* while */  /* repeat until EOF */
} /* getinput */

/*=================================================
       input read line
***************************************************/

int readline(char *line)
{
  char c;
  int i;
  int line_end, something;

  i = 0;
  line_end = FALSE;
  something = FALSE;

  do
  {
    c = getc(fp);
    if ((c != EOF) && (c != '\n'))
    {
    /* both , and ; will become <space>, the separator I assume later */
      if ((c == ' ') || (c == ',') || (c == ';')) 
           c = ' '; 
      else 
           something = TRUE;
      line[i] = c;
      printf("%c", c);
      i++;
    }
    else if((c == '\n') && (!something))
        i = 0; 
    else line_end = TRUE;
  }
  while (line_end == FALSE);

  if (c == '\n') 
  {
    line[i] = c;
    printf("%c", c);
    line[i+1] = '\0';
    return(EOF + 1);
  }
  else return(EOF);
}  /* readline */

