#include <math.h>


/*
 * Invert the matrix xa.
 *
 * A should be dimensioned (n x n).
 */

void
matrix_invert(double **xa, int n)
	double **xa;
	int n;
{
	register int i,j,k;
	register double **a;
	register double *v;
	register double scale;

	/* Okay, I have seen so-called optimizing compilers screw      */
	/* optimizations like this up... that's why this line is here. */
	/* In general, it's a good idea not to leave everything to the */
	/* compiler... because unless you wrote the compiler, you      */
	/* shouldn't assume that it does all those nice things you     */
	/* might think it does  (even with the -O option on...)        */

	a = xa;

	/* V can be thought of as an extra column for the elimination. */
	v = (double *) malloc((long)n * sizeof(double));
	if (!v) return(-1);
	
	for (j=0;j<n;j++) {		
	
		/* First, prepare appended column. */
		for (k=0;k<n;k++) v[k] = 0;
		
		/* Second, normalize jth row w.r.t. jth column */
		scale = a[j][j];
		for (i=0;i<n;i++) a[j][i] /= scale;
		v[j] = 1 / scale;
		
		for (i=0;i<n;i++) {
			if (i != j) {
				scale = a[i][j] / a[j][j];
				for (k=0;k<n;k++) {	
					a[i][k] -= scale * a[j][k];
				}
				v[i] -= scale * v[j];		/* Do the appended column, too. */
			}
		}
		/* Now move the appended column onto the eliminated column */
		for (i=0;i<n;i++) {
			a[i][j] = v[i];
		}
	}
	free(v);
}

