#include <math.h>
#include <stdio.h>

double next_value();
char *malloc();

#define N 9

double old_global_matrix[16] = {
	3,  6, 3,  2,
	6,  7, 5, 10,
	3,  5, 2,  4,
	2, 10, 4,  4
};

double global_matrix[81] = {
  3,  0,  0,  0,  0,  0,  0,  0,  0,
  6,  7,  0,  0,  0,  0,  0,  0,  0,
  3,  5,  2,  0,  0,  0,  0,  0,  0,
  2, 10,  4,  4,  0,  0,  0,  0,  0,
  6,  7,  1,  3,  6,  0,  0,  0,  0,
  2,  3,  1,  7,  2,  8,  0,  0,  0,
  1,  3,  5,  7,  9,  2,  4,  0,  0,
  3,  1,  4,  1,  5,  9,  2,  6,  0,
  2, 13,  1,  7,  3,  2,  8,  4,  2
  };


main()
{
  double **a, **b, **c;
  double sum;
  int i,j,k;
  
  printf("Good morning, Dave.\n");
  
  a = (double **) malloc((long)N * sizeof(double *));
  if (!a) {
    printf("Unable to allocate memory for a matrix\n");
    return(-1);
  }
  for (i=0;i<N;i++) {
    a[i] = (double *) malloc((long)N * sizeof(double));
    if (!a[i]) {
      printf("Unable to allocate memory for %dth row in a matrix\n",i);
      return(-1);
    }
  }
  
  b = (double **) malloc((long)N * sizeof(double *));
  if (!b) {
    printf("Unable to allocate memory for b matrix\n");
    return(-1);
  }
  for (i=0;i<N;i++) {
    b[i] = (double *) malloc((long)N * sizeof(double));
    if (!b[i]) {
      printf("Unable to allocate memory for %dth row in b matrix\n",i);
      return(-1);
    }
  }
  
  c = (double **) malloc((long)N * sizeof(double *));
  if (!c) {
    printf("Unable to allocate memory for c matrix\n");
    return(-1);
  }
  for (i=0;i<N;i++) {
    c[i] = (double *) malloc((long)N * sizeof(double));
    if (!c[i]) {
      printf("Unable to allocate memory for %dth row in c matrix\n",i);
      return(-1);
    }
  }
  
  k = 0;
  for (i=0;i<N;i++) {
    for (j=0;j<N;j++) a[i][j] = global_matrix[k++];
  }

  /* Make matrix symmetric */
  for (j=0;j<N;j++) {
    for (i=0;i<j;i++) {
      a[i][j] = a[j][i];
    }
  }
  
  print_matrix(a,N,N,"A before inversion");
  
  for (i=0;i<N;i++) {
    for (j=0;j<N;j++) {
      b[i][j] = a[i][j];
    }
  }
  
  fast_matrix_invert(a,N);
  
  print_matrix(a,N,N,"A after inversion");
  
  for (i=0;i<N;i++) {
    for (j=0;j<N;j++) {
      for (sum=k=0;k<N;k++) {
	sum += a[i][k] * b[k][j];
      }
      c[i][j] = sum;
    }
  }
  
  print_matrix(c,N,N,"A*inv(A)");
}

